/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.crail.hdfs;

import java.net.URI;
import org.apache.hadoop.conf.Configuration;

public class GetConf {
	
	public static void main(String[] args) throws Exception {
		if (args.length < 1){
			System.out.println("Needs at least one argument");
		}
		
		String key = args[0];
		Configuration conf = new Configuration();
		if (key.equalsIgnoreCase("namenode")){
			String defaultFS = conf.get("fs.defaultFS");
			URI uri = new URI(defaultFS);
			System.out.println(uri.getHost());
		} else {
			String value = conf.get(key);
			System.out.println(value);
		}
	}

}
